//
// Message Catalog for Mike Bradys plugin nodes
//
// Header Section
//FacilityNames=(
//   System=0x0FF
//   Application=0xFFF
//   ) 
//LanguageNames=(
//   English=1:MBEN_US1
//   )
// Message Section
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: MJB_NODE_FACTORY_CREATED
//
// MessageText:
//
//  Broker (%1!s!) has created plugin node factory %2!s! successfully.
//
#define MJB_NODE_FACTORY_CREATED         ((int)0x40000001L)

//
// MessageId: MJB_NODE_CLASS_CREATION_FAILED
//
// MessageText:
//
//  Broker (%1!s!) plugin node factory %2!s! has failed to create node %3!s!.
//
#define MJB_NODE_CLASS_CREATION_FAILED   ((int)0xC0000002L)

//
// MessageId: MJB_RESOURCE_CREATION_FAILED
//
// MessageText:
//
//  Broker (%1!s!) plugin node factory %2!s! has failed to create resource %3!s!.
//
#define MJB_RESOURCE_CREATION_FAILED     ((int)0xC0000003L)

//
// MessageId: MJB_UNRECOGNISED_NODE
//
// MessageText:
//
//  Broker (%1!s!) called evaluate() with unrecognised node name (%2!s!).
//
#define MJB_UNRECOGNISED_NODE            ((int)0xC0000004L)

//
// MessageId: MJB_UNRECOGNISED_NODE_CREATE_CONTEXT
//
// MessageText:
//
//  Broker (%1!s!) called createContext() with unrecognised node name (%2!s!).
//
#define MJB_UNRECOGNISED_NODE_CREATE_CONTEXT ((int)0xC0000005L)

//
// MessageId: MJB_ALARM_THREAD_INIT_FAILED
//
// MessageText:
//
//  Broker (%1!s!) failed to initialise alarm thread. Message text is '%2!s!'.
//
#define MJB_ALARM_THREAD_INIT_FAILED     ((int)0xC0000006L)

//
// MessageId: MJB_TERMINAL_DOES_NOT_EXIST
//
// MessageText:
//
//  Broker (%1!s!) detected that requested terminal %2!s! does not exist in message flow.
//
#define MJB_TERMINAL_DOES_NOT_EXIST      ((int)0xC0000007L)

//
// MessageId: MJB_TERMINAL_NOT_ATTACHED
//
// MessageText:
//
//  Broker (%1!s!) detected that requested terminal %2!s! is not attached to message flow.
//
#define MJB_TERMINAL_NOT_ATTACHED        ((int)0xC0000008L)

//
// MessageId: MJB_MESSAGE_NOT_PROPAGATED
//
// MessageText:
//
//  Broker (%1!s!) detected that an error occurred when propagating message (rc = %2!s!).
//
#define MJB_MESSAGE_NOT_PROPAGATED       ((int)0xC0000009L)

//
// MessageId: MJB_NODE_CONTEXT_DELETED
//
// MessageText:
//
//  Broker (%1!s!) successfully deleted context for node %2!s! (label=%3!s!).
//
#define MJB_NODE_CONTEXT_DELETED         ((int)0x4000000AL)

//
// MessageId: MJB_NODE_FACTORY_CREATED_UNIX
//
// MessageText:
//
//  Broker has created plugin node factory %1!s! successfully.
//
#define MJB_NODE_FACTORY_CREATED_UNIX    ((int)0x4000000BL)

//
// MessageId: MJB_FAILED_TO_LOCATE_SYNTAX_ELEMENT
//
// MessageText:
//
//  Broker (%1!s!) failed to locate specified syntax element in message.  Element path is %2!s!.  Message propagated to noDataCopied terminal.
//
#define MJB_FAILED_TO_LOCATE_SYNTAX_ELEMENT ((int)0xC000000CL)

//
// MessageId: MJB_FAILED_TO_SERIALISE_SYNTAX_ELEMENT_DATA
//
// MessageText:
//
//  Broker (%1!s!) failed to serialise data from specified syntax element in message.  Element path is %2!s!.  Message propagated to failure terminal.
//
#define MJB_FAILED_TO_SERIALISE_SYNTAX_ELEMENT_DATA ((int)0xC000000DL)

//
// MessageId: MJB_FAILED_TO_INFLATE_SERIALISED_SYNTAX_ELEMENT_DATA
//
// MessageText:
//
//  Broker (%1!s!) failed to inflate serialised data at specified syntax element in message.  Element path is %2!s!.  Message propagated to failure terminal.
//
#define MJB_FAILED_TO_INFLATE_SERIALISED_SYNTAX_ELEMENT_DATA ((int)0xC000000EL)

//
// MessageId: MJB_INVALID_COPY_FROM_SYNTAX_ELEMENT_NAME
//
// MessageText:
//
//  Broker (%1!s!) detected that the syntax element name specified in the %2!s! property of node %3!s! is invalid.  A valid name must be either 'Root' or must begin with 'Root.'.
//
#define MJB_INVALID_COPY_FROM_SYNTAX_ELEMENT_NAME ((int)0xC000000FL)

//
// MessageId: MJB_INVALID_COPY_TO_SYNTAX_ELEMENT_NAME
//
// MessageText:
//
//  Broker (%1!s!) detected that the syntax element name specified in the %2!s! property of node %3!s! is invalid.  A valid name must begin with 'Root.'.
//
#define MJB_INVALID_COPY_TO_SYNTAX_ELEMENT_NAME ((int)0xC0000010L)

//
// MessageId: MJB_INSUFFICIENT_GLOBAL_STORAGE
//
// MessageText:
//
//  Broker (%1!s!) detected that there is insufficient free storage available in the global storage pool to satisfy an allocation request.  Increase the size of the shared memory segment.
//
#define MJB_INSUFFICIENT_GLOBAL_STORAGE  ((int)0xC0000011L)

//
// MessageId: MJB_FATAL_IN_GLOBAL_STORAGE
//
// MessageText:
//
//  Broker (%1!s!) detected a fatal error in the shared memory routines.  It is likely that the shared memory is corrupt.  You should stop and restart the broker.
//
#define MJB_FATAL_IN_GLOBAL_STORAGE      ((int)0xC0000012L)

//
// MessageId: MJB_FAILED_TO_ATTACH_SHARED_MEMORY
//
// MessageText:
//
//  Broker (%1!s!) failed to attach shared memory segment in Execution Group.
//
#define MJB_FAILED_TO_ATTACH_SHARED_MEMORY ((int)0xC0000013L)

//
// MessageId: MJB_SHARED_MEMORY_GARBAGE_COLLECTION_THREAD_INIT_FAILED
//
// MessageText:
//
//  Broker (%1!s!) failed to initialise shared memory garbage collection thread. Message text is '%2!s!'.
//
#define MJB_SHARED_MEMORY_GARBAGE_COLLECTION_THREAD_INIT_FAILED ((int)0xC0000014L)

//
// MessageId: MJB_FIELD_NOT_FOUND
//
// MessageText:
//
//  Broker (%1!s!) failed to locate %2!s! field in the input message.  The message has been propagated to the failure terminal.
//
#define MJB_FIELD_NOT_FOUND              ((int)0xC0000015L)

//
// MessageId: MJB_FATAL_IN_FREE_GLOBAL_STORAGE
//
// MessageText:
//
//  Broker (%1!s!) detected a fatal error in the shared memory FREE routines. Message text is (%2!s!).
//
#define MJB_FATAL_IN_FREE_GLOBAL_STORAGE ((int)0xC0000016L)

// End of Message Data
