#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <cmqc.h>
#include <time.h>

#define KYPROBLEM 1
#define BUILDRFH2 0
#define NUM_MESSAGES 20

//	     "<emptyTag>"\
//	     "</emptyTag>"\
//             "<tag5>data5</tag5>"\
//
//	     "<innerMost>"\
//             "<tag5>data5</tag5>"\
//	     "</innerMost>"\
//


#define MJB_XML_MESSAGE \
"<outer>"\
     "<tag1><mjb value='xyz'>aaa</mjb></tag1>"\
     "<tag2>data2</tag2>"\
     "<tag3>data3</tag3>"\
	 "<inner>"\
	     "<innerMost>"\
             "<tag5>data5</tag5>"\
	     "</innerMost>"\
	     "<anotherInnerMost>"\
	     "</anotherInnerMost>"\
	 "</inner>"\
     "<tag4>data4</tag4>"\
"</outer>"
















#if 1

#define XML_MESSAGE \
"<outer>"\
     "<tag1><mjb value='xyz'>aaa</mjb></tag1>"\
     "<tag2>data2</tag2>"\
     "<tag3>data3</tag3>"\
	 "<inner>"\
	     "<innerMost>"\
             "<tag5>data5</tag5>"\
	     "</innerMost>"\
	     "<anotherInnerMost>"\
             "<tag5>data5</tag5>"\
	     "</anotherInnerMost>"\
	 "</inner>"\
     "<tag4>data4</tag4>"\
"</outer>"

#elif 0 

#define XML_MESSAGE \
"<Container>"\
	 "<myTag></myTag>"\
     "<CorrelId>xxx</CorrelId>"\
     "<QName>yyy</QName>"\
     "<NewQAlias>zzz</NewQAlias>"\
"</Container>"

#elif 0

#define XML_MESSAGE \
"<Container>"\
	 "<myTag></myTag>"\
"</Container>"

#elif 0

#define XML_MESSAGE \
"<Container>"\
	 "<myTag/>"\
"</Container>"

#elif 0

#define XML_MESSAGE \
"<myTag></myTag>"

#elif 0

#define XML_MESSAGE \
"abcdefgh"

#else

#define XML_MESSAGE \
"<?xml version='1.0' encoding='UTF-8'?>"\
"<!DOCTYPE W_SupplierPOAck SYSTEM '1.j3w5ucd5.pecb.2'>"\
"<?Alliance:BODefInfo name=\"W_SupplierPOAck\""\
                    " defID=\"1.j3w5ucd5.pecb.2\""\
                    " owner=\"IBM Woolworths.999203\""\
                    " version=\"2\""\
                    " GUID=\"1.j3w5ucd5.pecb.\""\
                    " externalID=\"111\""\
                    " editable=\"false\"?>"\
"<W_SupplierPOAck>"\
"  <AcknowledgementNumber>30778</AcknowledgementNumber>"\
"  <W_SupplierPO>"\
"    <PONumber>307</PONumber>"\
"    <ProductID>15</ProductID>"\
"    <ProductQty>78.</ProductQty>"\
"    <SupplierID>251</SupplierID>"\
"    <WarehouseID>311</WarehouseID>"\
"    <ProductDesc> </ProductDesc>"\
"    <Notes>This is a valid Order</Notes>"\
"  </W_SupplierPO>"\
"</W_SupplierPOAck>"




#endif




#define REQUEST_Q "I1.Q"
#define REPLY_Q "O1.Q"

#define NUM_QUEUES 1
#if defined(WIN32)
    #define QM_DEFAULT "NT_QM"
#elif defined(_AIX)
    #define QM_DEFAULT "SEAIX_QM"
#elif defined(_SOLARIS)
    #define QM_DEFAULT "SUN_QM"
#elif defined(_HPUX)
    #define QM_DEFAULT "HP_QM"
#endif

#if !defined(IN)
    #define IN
#endif
#if !defined(OUT)
    #define OUT
#endif
#if !defined(INOUT)
    #define INOUT
#endif

#if !defined(TRUE)
    #define TRUE 1
#endif

#if !defined(FALSE)
    #define FALSE 0
#endif

#if !defined(bool_t)
    #define bool_t int
#endif

#if !defined(retCode_t)
    #define retCode_t int
#endif

#define MQS_MSG_ID_LENGTH 24L
#define MQS_CORREL_ID_LENGTH 24L


typedef unsigned long MQS_connHandle_t;
typedef unsigned long MQS_queueHandle_t;
typedef unsigned long MQS_msgDesc_t;
typedef int MQS_msgFormat_t;

/* message formats */
typedef enum MQS_format {
    MQS_NONE,
	MQS_RFH2
} MQS_format_t;

/* mode for opening queue */
typedef enum MQS_openMode {
    MQS_READ,
    MQS_READ_AND_BROWSE,
    MQS_WRITE,
	MQS_BROWSE,
	MQS_READ_AND_WRITE,
	MQS_READ_AND_WRITE_AND_BROWSE
} MQS_openMode_t;

/* syncpoint indicator */
typedef enum MQS_UOWIndicator {
    MQS_SYNCPOINT,
	MQS_NO_SYNCPOINT,
	MQS_SYNCPOINT_IF_PERSISTENT
} MQS_UOWIndicator_t;

/* persistence indicator */
typedef enum MQS_persistenceIndicator {
    MQS_DEFAULT,
    MQS_PERSISTENT,
	MQS_NON_PERSISTENT
} MQS_persistenceIndicator_t;

typedef enum MQS_msgFormatValue {
	MQS_FORMAT_NONE,
	MQS_FORMAT_RF,
	MQS_FORMAT_RF2,
	MQS_FORMAT_STRING,
	MQS_FORMAT_TRIGGER,
	MQS_FORMAT_XMITQ
} MQS_msgFormatValue_t;

/* message content descriptor */
typedef struct MQS_mcd {
    char *Msd,
         *Set,
         *Type,
         *Fmt;
} MQS_mcd_t;
#define MQS_MCD_DEFAULT NULL,   \
                        NULL,   \
                        NULL,   \
						NULL

/* structure for holding up to 20 string values */
typedef struct MQS_valueSet {
	int numValues;
	char *value[20];
} MQS_valueSet_t;
#define MQS_VALUESET_DEFAULT 0,                   \
                        NULL,NULL,NULL,NULL,NULL, \
                        NULL,NULL,NULL,NULL,NULL, \
                        NULL,NULL,NULL,NULL,NULL, \
                        NULL,NULL,NULL,NULL,NULL

/* publish/subscribe commands */
typedef struct MQS_psc {
    char *Command,
         *DelOpt,
         *SubPoint,
         *QMgrName,
         *QName,
         *PubTime,
         *SeqNum;
    MQS_valueSet_t *RegOpt,
                   *Topic,
                   *PubOpt,
                   *Filter;
} MQS_psc_t;

/* publish/subscribe command response */
typedef struct MQS_pscr {
    char *Command,
         *Topic,
         *Filter,
         *RegOpt,
         *DelOpt,
         *PubOpt,
         *SubPoint,
         *QMgrName,
         *QName,
         *PubTime,
         *SeqNum,
         *Completion,
         *Response,
         *Reason;
} MQS_pscr_t;

/* usr folder - not implemented yet */
typedef struct usr {
	char *userXMLData;
} MQS_usr_t;
#define MQS_USR_DEFAULT NULL

/* ASX specific folder */
typedef struct asx {
	char *asxXMLData;
} MQS_asx_t;
#define MQS_ASX_DEFAULT NULL

typedef struct MQS_svcFolderDetails {
    MQS_mcd_t *mcdP;
    MQS_psc_t *pscP;
    MQS_pscr_t *pscrP;
    MQS_usr_t *usrP;
	MQS_asx_t *asxP;
} MQS_svcFolderDetails_t;
#define MQS_SVCFOLDERDETAILS_DEFAULT NULL,   \
                                     NULL,   \
                                     NULL,   \
						             MQS_USR_DEFAULT, \
									 MQS_ASX_DEFAULT



#define bool_t int

#define ADD_TAG_DATA(__data, __tag)            \
		if (__data)                            \
		{                                      \
			buildTagAndData(__tag,             \
				            __data,            \
							tempBuffer,        \
							&tempBufferOffset, \
							&firstTag);        \
		}

#define CALC_TAG_LENGTH(__total, __tagValue, __tagName) \
if (__tagValue) \
	__total += (2 * strlen(__tagName)) + 5 + strlen(__tagValue);

#define ADD_TAG_DATA_SET(__dataset, __tag)          \
        if (__dataset)                              \
		{                                           \
            int i;                                  \
            for (i=0; i<__dataset->numValues; i++)  \
			{                                       \
				buildTagAndData(__tag,              \
								__dataset->value[i],\
								tempBuffer,         \
								&tempBufferOffset,  \
								&firstTag);         \
			}                                       \
		}

#define CALC_TAG_SET_LENGTH(__total, __tagSet, __tagName) \
if (__tagSet)                                       \
		{                                           \
            int i;                                  \
            for (i=0; i<__tagSet->numValues; i++)  \
			{                                       \
  __total += (2 * strlen(__tagName)) + 5 + strlen(__tagSet->value[i]); \
			}                                       \
		}

#define FALSE 0
#define TRUE 1
#define MQS_QM_EYECATCHER "QM_CONN "
#define MQS_Q_EYECATCHER  "Q_HANDLE"
#define STORAGE_INCREMENT 200
#define BLANKS_16 "                "
#define PSC_START "<psc>"
#define PSC_END "</psc>"
#define MCD_START "<mcd>"
#define MCD_END "</mcd>"
#define USR_START "<usr>"
#define USR_END "</usr>"

#if 1
#define AIM_FOLDER_START "<au_com_asx_aim>"
#define AIM_FOLDER_END "</au_com_asx_aim>"
#else
#define AIM_FOLDER_START "<au.com.asx.aim>"
#define AIM_FOLDER_END "</au.com.asx.aim>"
#define AIM_FOLDER_START "<ASX_Folder>"
#define AIM_FOLDER_END "</ASX_Folder>"
#endif

#define COMMAND "Command"
#define TOPIC "Topic"
#define SUBPOINT "SubPoint"
#define REGOPT "RegOpt"
#define PUBOPT "PubOpt"
#define DELOPT "DelOpt"
#define FILTER "Filter"
#define MSD "Msd"
#define SET "Set"
#define TYPE "Type"
#define FMT "Fmt"
#define QMGRNAME "QMgrName"
#define QNAME "QName"
#define PUBTIME "PubTime"
#define SEQNUM "SeqNum"


void addToBuffer(char *buffer,
				 int *offsetP,
				 char *string,
			     bool_t *firstTagP)
{

	/* if this is the first tag, allow for folder length field */
	/* (nameValueLength) to be stored                          */
	if (*firstTagP)
	{
		*offsetP += 4;
		*firstTagP = FALSE;
	}
	memcpy(buffer+(*offsetP), string, strlen(string));
	*offsetP += strlen(string);
	return;
}

void buildTagAndData(char *tag,
					 char *data,
					 char *buffer,
					 int *offsetP,
				     bool_t *firstTagP)
{
    addToBuffer(buffer, offsetP, "<", firstTagP);
    addToBuffer(buffer, offsetP, tag, firstTagP);
    addToBuffer(buffer, offsetP, ">", firstTagP);
    addToBuffer(buffer, offsetP, data, firstTagP);
    addToBuffer(buffer, offsetP, "</", firstTagP);
    addToBuffer(buffer, offsetP, tag, firstTagP);
    addToBuffer(buffer, offsetP, ">", firstTagP);

	return;
}

int increaseBuffer(char **bufferP,
				   int  *lengthP,
				   int increment)
{
	*lengthP += increment;
	*bufferP = (char *)realloc(*bufferP, *lengthP);
	return(increment);
}

int doPadding(char **bufferP,
		      int *bufferSpaceP,
		      int *bufferLengthP,
			  bool_t *firstTagP,
		      int *bufferOffsetP,
		      int startOffset,
		      int boundary)
{
	int endOffset,
	    folderLength,
	    lengthBeforePadding,
		lengthAfterPadding,
		padLength;
	char blanks[] = "    ";
	char blankString[16];

	/* if necessary, pad to required boundary */
	endOffset = *bufferOffsetP;
	folderLength = endOffset - startOffset;
	lengthBeforePadding = folderLength;
	lengthAfterPadding = ((lengthBeforePadding + boundary - 1)/boundary)*boundary;
	padLength = lengthAfterPadding - lengthBeforePadding;

	if (padLength)
	{
		if (*bufferSpaceP < boundary-1) /* nominal amount of space needed */
		{
			*bufferSpaceP += increaseBuffer(bufferP, bufferLengthP, boundary);
		}
		memset(blankString, 0, sizeof(blankString));
		memcpy(blankString, BLANKS_16, padLength);
		addToBuffer(*bufferP, bufferOffsetP, blankString, firstTagP);
	}

	return(padLength);
}

int lengthOfFolderData(MQS_svcFolderDetails_t *folderDetailsP)
{
	int totalBytes = 0;

	/* run through the possible folders, building each into the temporary buffer */
	if (folderDetailsP->mcdP)
	{
		totalBytes += strlen(MCD_START);

		CALC_TAG_LENGTH(totalBytes, folderDetailsP->mcdP->Msd, MSD);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->mcdP->Set, SET);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->mcdP->Type, TYPE);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->mcdP->Fmt, FMT);
			
		totalBytes += strlen(MCD_END);

        totalBytes += 4 + 4; /* max. padding + 4 byte length field */
	}

	/* process ASX folder data */
	if (folderDetailsP->asxP)
	{
		totalBytes += strlen(AIM_FOLDER_START);
		totalBytes += strlen(folderDetailsP->asxP->asxXMLData);
		totalBytes += strlen(AIM_FOLDER_END);

        totalBytes += 4 + 4; /* max. padding + 4 byte length field */
	}

	if (folderDetailsP->pscP)
	{
		totalBytes += strlen(PSC_START);

		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->Command, COMMAND);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->DelOpt, DELOPT);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->SubPoint, SUBPOINT);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->QMgrName, QMGRNAME);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->QName, QNAME);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->PubTime, PUBTIME);
		CALC_TAG_LENGTH(totalBytes, folderDetailsP->pscP->SeqNum, SEQNUM);

		CALC_TAG_SET_LENGTH(totalBytes, folderDetailsP->pscP->RegOpt, REGOPT);
		CALC_TAG_SET_LENGTH(totalBytes, folderDetailsP->pscP->PubOpt, PUBOPT);
		CALC_TAG_SET_LENGTH(totalBytes, folderDetailsP->pscP->Filter, FILTER);
		CALC_TAG_SET_LENGTH(totalBytes, folderDetailsP->pscP->Topic, TOPIC);
		
		totalBytes += strlen(PSC_END);

        totalBytes += 4 + 4; /* max. padding + 4 byte length field */
	}

	if (folderDetailsP->pscrP)
	{
		/* not implemented yet... */
	}

	/* add 16 bytes for total folder padding */
	totalBytes += 16;

	return(totalBytes);
}


/*************************
 * MQS_buildRFH2Header
 ********************h*****/
char * MQS_buildRFH2Header(MQS_svcFolderDetails_t *folderDetailsP,
					       int msgLength,
					       MQS_msgFormatValue_t msgFormat,
					       int *headerLengthP)
{
    MQRFH2 RFHeader = {MQRFH2_DEFAULT};   /* MQI header */
	char *tempBuffer = NULL,
		 *lastLengthField;
	int tempBufferLength = 0,
		tempBufferSpace = 0,
		tempBufferOffset = 0,
		lengthBefore,
		lengthAfter;
	bool_t firstTag = TRUE;
	int folderLength,
		startOffset;

	/* allocate some buffer to begin with and allow space for RFH2... */
	tempBuffer = (char *)malloc(sizeof(MQRFH2) + lengthOfFolderData(folderDetailsP));
	memset(tempBuffer, 0, sizeof(MQRFH2) + STORAGE_INCREMENT);
	tempBufferSpace = tempBufferLength = sizeof(MQRFH2) + STORAGE_INCREMENT;
	tempBufferOffset = sizeof(MQRFH2);
	tempBufferSpace -= sizeof(MQRFH2);

	/* run through the possible folders, building each into the temporary buffer */
	printf("testing mcdP\n");

	if (folderDetailsP->mcdP)
	{
		fprintf(stderr,"mcdP set\n");
		firstTag = TRUE;
		startOffset = tempBufferOffset;

		if (tempBufferSpace < STORAGE_INCREMENT) /* nominal amount of space needed */
		{
			tempBufferSpace += increaseBuffer(&tempBuffer, &tempBufferLength, 
				                              STORAGE_INCREMENT);
		}

		/* add leading tag */
		addToBuffer(tempBuffer, &tempBufferOffset, MCD_START, &firstTag);

		ADD_TAG_DATA(folderDetailsP->mcdP->Msd, MSD);
		ADD_TAG_DATA(folderDetailsP->mcdP->Set, SET);
		ADD_TAG_DATA(folderDetailsP->mcdP->Type, TYPE);
		ADD_TAG_DATA(folderDetailsP->mcdP->Fmt, FMT);

		/* add closing tag */
		addToBuffer(tempBuffer, &tempBufferOffset, MCD_END, &firstTag);

        doPadding(&tempBuffer, 
			      &tempBufferSpace, 
				  &tempBufferLength, 
				  &firstTag,
				  &tempBufferOffset, 
				  startOffset,
				  4);

		folderLength = tempBufferOffset - startOffset - 4;

		/* fill in the length value for this folder */
	    memcpy(tempBuffer+startOffset, &folderLength, 4);
	}

	/* process ASX folder data */
	printf("testing asxP\n");
	if (folderDetailsP->asxP)
	{
		printf("asxP set\n");
		firstTag = TRUE;
		startOffset = tempBufferOffset;

		if (tempBufferSpace < STORAGE_INCREMENT) /* nominal amount of space needed */
		{
			tempBufferSpace += increaseBuffer(&tempBuffer, &tempBufferLength, 
				                              STORAGE_INCREMENT);
		}

		/* add leading tag */
		addToBuffer(tempBuffer, &tempBufferOffset, AIM_FOLDER_START, &firstTag);

		/* add the user data */
		addToBuffer(tempBuffer, &tempBufferOffset, 
			         folderDetailsP->asxP->asxXMLData, &firstTag);

		/* add closing tag */
		addToBuffer(tempBuffer, &tempBufferOffset, AIM_FOLDER_END, &firstTag);

        doPadding(&tempBuffer, 
			      &tempBufferSpace, 
				  &tempBufferLength, 
				  &firstTag,
				  &tempBufferOffset, 
				  startOffset,
				  4);

		folderLength = tempBufferOffset - startOffset - 4;

		/* fill in the length value for this folder */
	    memcpy(tempBuffer+startOffset, &folderLength, 4);
	}

	printf("testing pscP\n");
	if (folderDetailsP->pscP)
	{
		firstTag = TRUE;
		startOffset = tempBufferOffset;

		if (tempBufferSpace < STORAGE_INCREMENT) /* nominal amount of space needed */
		{
			tempBufferSpace += increaseBuffer(&tempBuffer, &tempBufferLength, 
				                                STORAGE_INCREMENT);
		}

	    /* add leading tag */
		addToBuffer(tempBuffer, &tempBufferOffset, PSC_START, &firstTag);

		ADD_TAG_DATA(folderDetailsP->pscP->Command, COMMAND);
		ADD_TAG_DATA(folderDetailsP->pscP->DelOpt, DELOPT);
		ADD_TAG_DATA(folderDetailsP->pscP->SubPoint, SUBPOINT);
		ADD_TAG_DATA(folderDetailsP->pscP->QMgrName, QMGRNAME);
		ADD_TAG_DATA(folderDetailsP->pscP->QName, QNAME);
		ADD_TAG_DATA(folderDetailsP->pscP->PubTime, PUBTIME);
		ADD_TAG_DATA(folderDetailsP->pscP->SeqNum, SEQNUM);

		ADD_TAG_DATA_SET(folderDetailsP->pscP->RegOpt, REGOPT);
		ADD_TAG_DATA_SET(folderDetailsP->pscP->PubOpt, PUBOPT);
		ADD_TAG_DATA_SET(folderDetailsP->pscP->Filter, FILTER);
		ADD_TAG_DATA_SET(folderDetailsP->pscP->Topic, TOPIC);

		/* add closing tag */
		addToBuffer(tempBuffer, &tempBufferOffset, PSC_END, &firstTag);

        doPadding(&tempBuffer, 
			      &tempBufferSpace, 
				  &tempBufferLength, 
				  &firstTag,
				  &tempBufferOffset, 
				  startOffset,
				  4);

		folderLength = tempBufferOffset - startOffset - 4;

		/* fill in the length value for this folder */
	    memcpy(tempBuffer+startOffset, &folderLength, 4);
	}

	printf("testing pscrP\n");
	if (folderDetailsP->pscrP)
	{
		/* not implemented yet... */
	}

	lastLengthField = tempBuffer+startOffset;

    /*
     * Now we align the end of the MQRFH and Service Folder structures on a 
     * 16 byte boundary and pad with blanks. This is optional, but is recommended 
	 * when passing data between different platforms since it can simplify 
	 * data conversion.  The padding is added to the last folder.
     */
	lengthBefore = tempBufferOffset;
    doPadding(&tempBuffer, 
			  &tempBufferSpace, 
			  &tempBufferLength, 
			  &firstTag,
			  &tempBufferOffset, 
			  startOffset,
			  16);
	lengthAfter = tempBufferOffset;

	folderLength += (lengthAfter - lengthBefore);

	/* fill in the length value for the last folder */
	memcpy(lastLengthField, &folderLength, 4);

	/* initialise the RFH2 header */
    RFHeader.StrucLength = tempBufferOffset;
	RFHeader.NameValueCCSID = 1208;
#if 0
    RFHeader.CodedCharSetId = 0;
#endif
	switch (msgFormat)
	{
	    case MQS_FORMAT_NONE:
            memcpy(RFHeader.Format, MQFMT_NONE, sizeof(RFHeader.Format));
			break;
	    case MQS_FORMAT_RF:
            memcpy(RFHeader.Format, MQFMT_RF_HEADER, sizeof(RFHeader.Format));
			break;
	    case MQS_FORMAT_RF2:
            memcpy(RFHeader.Format, MQFMT_RF_HEADER_2, sizeof(RFHeader.Format));
			break;
	    case MQS_FORMAT_STRING:
            memcpy(RFHeader.Format, MQFMT_STRING, sizeof(RFHeader.Format));
			break;
	    case MQS_FORMAT_TRIGGER:
            memcpy(RFHeader.Format, MQFMT_TRIGGER, sizeof(RFHeader.Format));
			break;
	    case MQS_FORMAT_XMITQ:
            memcpy(RFHeader.Format, MQFMT_XMIT_Q_HEADER, sizeof(RFHeader.Format));
			break;
		default:;
	}

#if 0
	/* temporary override... */
	memcpy(RFHeader.Format, "PXML    ", 8);
#endif

    /*
     * Set the necessary fields in the MQRFH to show that character string
     * data follows.  Also, use the same coded character set as the queue
     * manager, i.e. inherit the value.
     */
    RFHeader.CodedCharSetId = MQCCSI_INHERIT;

	/* copy RFH2 into buffer */
	memcpy(tempBuffer, &RFHeader, sizeof(RFHeader));

	/* return buffer and length to caller */
	*headerLengthP = RFHeader.StrucLength;
    return(tempBuffer);
}


int main(int argc, char *argv[])
{
	MQHCONN hConn;
	MQHOBJ requestHandle, replyHandle;
    MQLONG   openOptions;               /* MQOPEN options                */
    MQOD od = {MQOD_DEFAULT};           /* Object Descriptor */
    MQPMO pmo = {MQPMO_DEFAULT};        /* put message options */
    MQGMO gmo = {MQGMO_DEFAULT};        /* put message options */
	MQMD md,
		 mdDefault = {MQMD_DEFAULT};           /* Message Descriptor */
	MQLONG compCode,
		   reason;
	int msgFlow2 = 0;
	int i,
		j,
		messageLength,
		returnedMessageLength;
        char correlId[NUM_MESSAGES][MQ_CORREL_ID_LENGTH];
	char message[10000],
		 *qmName,
		 *requestQueue,
		 *replyQueue;
	int numMessages = NUM_MESSAGES; 
#if BUILDRFH2
	MQS_svcFolderDetails_t mySvc = {MQS_SVCFOLDERDETAILS_DEFAULT}; 
	char *rfh2;
	int rfh2Length;
#endif

	/* display usage template if requested */
    if (argc == 2 && argv[1][0] == '?' ||
        argc > 1 && argc != 4)
	{
		printf("Usage: %s < <queueManagerName> <requestQueue> <replyQueue>\n",
			    argv[0]);
		return(0);
	}

    if (argc > 1)
    {
        /* read in queue manager name */
		qmName = argv[1];

		/* now read the queue name(s) */
		requestQueue = argv[2];
		replyQueue = argv[3];
    }
    else
    {
		qmName = QM_DEFAULT;
		requestQueue = REQUEST_Q;
		replyQueue = REPLY_Q;
    }

	printf("Queue manager: %s\n", qmName);
	printf("Request queue: %s\n", requestQueue);
	printf("Reply queue: %s\n", replyQueue);

	/* connect to queue manager, assume default */
	MQCONN(qmName,
		   &hConn,
		   &compCode,
		   &reason);
	if (reason != MQRC_NONE)
	{
		printf("MQCONN failed with compcode=%d, reason=%d\n",
			   compCode, reason);
		exit(1);
	}

	/* open the request queue */
	strcpy(od.ObjectName, requestQueue);
	/* set the open mode */
	openOptions = MQOO_OUTPUT + MQOO_FAIL_IF_QUIESCING; /* open queue for output */

	MQOPEN(hConn,
		   &od,
		   openOptions,
		   &requestHandle,
		   &compCode,
		   &reason);
	if (reason != MQRC_NONE)
	{
		printf("MQOPEN for input queue '%s' failed with compcode=%d, reason=%d\n",
			   od.ObjectName, compCode, reason);
		exit(1);
	}

	/* open the reply queue */
	strcpy(od.ObjectName, replyQueue);

	/* set the open mode */
	openOptions = MQOO_INPUT_AS_Q_DEF + MQOO_FAIL_IF_QUIESCING; /* open queue for output */

	MQOPEN(hConn,
		   &od,
		   openOptions,
		   &replyHandle,
		   &compCode,
		   &reason);
	if (reason != MQRC_NONE)
	{
		printf("MQOPEN for reply queue '%s' failed with compcode=%d, reason=%d\n",
			   od.ObjectName, compCode, reason);
		exit(1);
	}

	for (i=0; i<numMessages; i++)
	{
		for (j=0; j<NUM_QUEUES; j++)
		{

			/* build BLOB type message or XML message */
#if 0
			sprintf(message, "This is iteration %d, request %d",
							 i+1, j+1);
#else
//			strcpy(message, XML_MESSAGE);
			strcpy(message, MJB_XML_MESSAGE);
			
#endif

#if BUILDRFH2
			/* build RFH2 message */
			printf("calling MQS_buildRFH2Header\n");
			rfh2 = MQS_buildRFH2Header(&mySvc,
					                   strlen(message),
						               MQS_FORMAT_STRING,
						               &rfh2Length);
			printf("called MQS_buildRFH2Header, rfh2length is %d\n", rfh2Length);
#endif






			printf("Putting request message '%s' on queue %s\n",
				    message, REQUEST_Q);
			messageLength = strlen(message);
			memcpy(&md, &mdDefault, sizeof(md));
			strcpy(md.ReplyToQ, "O1.Q");

			/* put the message on the queue */
			MQPUT(hConn,                   /* connection handle */
				  requestHandle,               /* object handle */
				  &md,                     /* message descriptor */
				  &pmo,                    /* put options */
				  (MQLONG)messageLength,   /* msg length */
				  message,                 /* message buffer */
				  &compCode,               /* completion code */
				  &reason);                /* reason code */
			if (reason != MQRC_NONE)
			{
				printf("MQPUT failed with compcode=%d, reason=%d\n",
					   compCode, reason);
				exit(1);
			}
	        memcpy(correlId[i], md.MsgId, MQ_MSG_ID_LENGTH);
		}
	}

//goto byp;

	/* read the reply/replies from the reply queue */
	for (i=0; i<numMessages; i++)
	{

		/* read message with matching correl id */
		fprintf(stderr, "about to read reply %d from queue %s\n", i+1, REPLY_Q);
		messageLength = sizeof(message);
		memcpy(&md, &mdDefault, sizeof(md));
		memcpy(md.CorrelId, correlId[i], MQ_CORREL_ID_LENGTH);

		gmo.Options = MQGMO_WAIT +
		              MQGMO_NO_SYNCPOINT;
        gmo.WaitInterval = MQWI_UNLIMITED;

		/* get the message from the queue */
		MQGET(hConn,                   /* connection handle */
			  replyHandle,             /* object handle */
			  &md,                     /* message descriptor */
			  &gmo,                    /* put options */
			  (MQLONG)messageLength,   /* msg length */
			  message,                 /* message buffer */
	  (long *)&returnedMessageLength,  /* returned message length */
			  &compCode,               /* completion code */
			  &reason);                /* reason code */
		if (reason != MQRC_NONE)
		{
			printf("MQGET failed with compcode=%d, reason=%d\n",
				   compCode, reason);
			exit(1);
		}

		fprintf(stderr, "Reply message is:\n'%.*s'\n",
			            returnedMessageLength, message);
	}

byp:;
	MQDISC(&hConn,
		   &compCode,
		   &reason);
	if (reason != MQRC_NONE)
	{
		printf("MQDISC failed with compcode=%d, reason=%d\n",
			   compCode, reason);
		exit(1);
	}

    return(0);
}

